/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <alucassch@gmail.com> and <brunomarcosespindola@gmail.com> wrote this file.
 * As long as you retain this notice you can do whatever you want with this stuff.
 * If we meet some day, and you think this stuff is worth it, you can buy
 * me a beer in return André Lucas Schlichting e Bruno Marcos Espindola
 * ----------------------------------------------------------------------------
 */

/*
 * Tradução da Licensa
 *  ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <alucassch@gmail.com> e <brunomarcosespindola@gmail.com>  escreveram esse código.
 * Enquanto você possui-lo, note que  você pode fazer o que desejar com ele. Se um
 * dia a gente se conhecer, e você achar que isso funciona, você pode nos comprar
 * uma cerveja em homenagem a André Lucas Schlichting e Bruno Marcos Espindola
 * ----------------------------------------------------------------------------
 */


package Damas;

import Protocolo.Mensagem;
import java.awt.Color;
import java.awt.Font;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.InetAddress;
import java.net.Socket;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 *
 * @author Andre
 */
public class Jogo extends javax.swing.JFrame {

    public String nomeLocal; //armazena o nome do jogador local
    public String nomeRemoto; //armazena o nome do adversário
    public String ip; //armazena o ip do servidor
    public int porta; //armazena a porta do servidor
    ObjectOutputStream output; //armazena o fluxo de saída do cliente
    ObjectInputStream input; //armazena o fluxo de entrada do cliente
    private Color cor; //armazena a cor da fonte que está sendo usada no bate-papo
    private Font fonte; //armazena o tipo de fonte usada no batepapo
    private StringBuffer chat; //armazena um 'histórico' do chat, para atualização da tela a cada nova mensagem
    private boolean minhaCor; //armazena qual é o jogador, se peças amarelas ou se peças vermelhas
    private int quantidadeAmarelas; //armazena a quantidade de peças amarelas
    private int quantidadeVermelhas; //armazena a quantidade de peças vermelhas
    private boolean primeiroJogo; //armazena a informação de que se é a primeira partida da conexão ou não
    private int placarAmarelo; //armazena as vitórias do jogador amarelo
    private int placarVermelho; //armazena as vitórias do jogador vermelho
    private StringBuffer historico;

    /** Creates new form Jogo */
    public Jogo() {
        initComponents();
        this.setLocationRelativeTo(null);
        //this.minhaVez = false;
        getRootPane().setDefaultButton(jBEnviar);
        this.cor = new Color(0, 0, 0);
        jEPBatePapo.setEditable(false);
        this.chat = new StringBuffer();
        this.jLVezAmarelo.setVisible(false);
        this.jLVezVermelho.setVisible(false);
        this.quantidadeAmarelas = 0;
        this.quantidadeVermelhas = 0;
        this.primeiroJogo = true;
        this.placarAmarelo = 0;
        this.placarVermelho = 0;
        this.historico = new StringBuffer();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPTabuleiro = new Painel(this);
        jPanel3 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jBEnviar = new javax.swing.JButton();
        jCBFonte = new javax.swing.JComboBox();
        jPCor = new javax.swing.JPanel();
        jTFBatePapo = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jEPBatePapo = new javax.swing.JTextPane();
        jPanel5 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTAHist = new javax.swing.JTextPane();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jTFAmarelo = new javax.swing.JTextField();
        jTFVermelho = new javax.swing.JTextField();
        jLVezVermelho = new javax.swing.JLabel();
        jLVezAmarelo = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jLVermelhasMortas = new javax.swing.JLabel();
        jLabel22 = new javax.swing.JLabel();
        jLAmarelasMortas = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        jLabel23 = new javax.swing.JLabel();
        jLPlacarVermelho = new javax.swing.JLabel();
        jLPLacarAmarelo = new javax.swing.JLabel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setResizable(false);

        jPTabuleiro.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPTabuleiro.setPreferredSize(new java.awt.Dimension(400, 400));
        jPTabuleiro.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPTabuleiroMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPTabuleiroLayout = new javax.swing.GroupLayout(jPTabuleiro);
        jPTabuleiro.setLayout(jPTabuleiroLayout);
        jPTabuleiroLayout.setHorizontalGroup(
            jPTabuleiroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 398, Short.MAX_VALUE)
        );
        jPTabuleiroLayout.setVerticalGroup(
            jPTabuleiroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 398, Short.MAX_VALUE)
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), "Bate-Papo", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Comic Sans MS", 1, 18))); // NOI18N

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Opções Bate-Papo", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Comic Sans MS", 1, 11))); // NOI18N

        jBEnviar.setText("Enviar");
        jBEnviar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBEnviarActionPerformed(evt);
            }
        });

        jCBFonte.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Fontes", "Arial", "Century Gotic", "Comic Sans MS", "Tahoma" }));

        jPCor.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jPCor.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPCorMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPCorLayout = new javax.swing.GroupLayout(jPCor);
        jPCor.setLayout(jPCorLayout);
        jPCorLayout.setHorizontalGroup(
            jPCorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 19, Short.MAX_VALUE)
        );
        jPCorLayout.setVerticalGroup(
            jPCorLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 25, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jCBFonte, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPCor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 109, Short.MAX_VALUE)
                .addComponent(jBEnviar))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPCor, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jCBFonte, javax.swing.GroupLayout.DEFAULT_SIZE, 29, Short.MAX_VALUE)
                    .addComponent(jBEnviar))
                .addContainerGap())
        );

        jEPBatePapo.setContentType("text/html");
        jEPBatePapo.setEditable(false);
        jEPBatePapo.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        jScrollPane1.setViewportView(jEPBatePapo);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 325, Short.MAX_VALUE)
            .addComponent(jTFBatePapo, javax.swing.GroupLayout.DEFAULT_SIZE, 325, Short.MAX_VALUE)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 450, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTFBatePapo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Histórico de Jogadas", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Comic Sans MS", 1, 18))); // NOI18N

        jTAHist.setEditable(false);
        jTAHist.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        jScrollPane2.setViewportView(jTAHist);

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 325, Short.MAX_VALUE)
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 49, Short.MAX_VALUE)
        );

        jLabel3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Damas/face-angry.png"))); // NOI18N

        jLabel4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Damas/face-worried.png"))); // NOI18N

        jTFAmarelo.setEditable(false);
        jTFAmarelo.setFont(new java.awt.Font("Tahoma", 0, 18));
        jTFAmarelo.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTFAmarelo.setText("Aguardando...");

        jTFVermelho.setEditable(false);
        jTFVermelho.setFont(new java.awt.Font("Tahoma", 0, 18));
        jTFVermelho.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTFVermelho.setText("Aguardando...");

        jLVezVermelho.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Damas/seta.gif"))); // NOI18N

        jLVezAmarelo.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Damas/seta.gif"))); // NOI18N

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("A");
        jLabel1.setPreferredSize(new java.awt.Dimension(45, 14));

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText("B");
        jLabel2.setPreferredSize(new java.awt.Dimension(45, 14));

        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel5.setText("C");
        jLabel5.setPreferredSize(new java.awt.Dimension(45, 14));

        jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel6.setText("D");
        jLabel6.setPreferredSize(new java.awt.Dimension(45, 14));

        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel7.setText("E");
        jLabel7.setPreferredSize(new java.awt.Dimension(45, 14));

        jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel8.setText("F");
        jLabel8.setPreferredSize(new java.awt.Dimension(45, 14));

        jLabel9.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel9.setText("G");
        jLabel9.setPreferredSize(new java.awt.Dimension(45, 14));

        jLabel10.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel10.setText("H");
        jLabel10.setPreferredSize(new java.awt.Dimension(45, 14));

        jLabel11.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel11.setText("1");
        jLabel11.setPreferredSize(new java.awt.Dimension(6, 45));

        jLabel12.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel12.setText("2");
        jLabel12.setPreferredSize(new java.awt.Dimension(6, 45));

        jLabel13.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel13.setText("3");
        jLabel13.setPreferredSize(new java.awt.Dimension(6, 45));

        jLabel14.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel14.setText("4");
        jLabel14.setPreferredSize(new java.awt.Dimension(6, 45));

        jLabel15.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel15.setText("5");
        jLabel15.setPreferredSize(new java.awt.Dimension(6, 45));

        jLabel16.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel16.setText("6");
        jLabel16.setPreferredSize(new java.awt.Dimension(6, 45));

        jLabel17.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel17.setText("7");
        jLabel17.setPreferredSize(new java.awt.Dimension(6, 45));

        jLabel18.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel18.setText("8");
        jLabel18.setPreferredSize(new java.awt.Dimension(6, 45));

        jLabel19.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Damas/face-angry.png"))); // NOI18N

        jLabel20.setFont(new java.awt.Font("Tempus Sans ITC", 1, 14));
        jLabel20.setText("R.I.P.");

        jLVermelhasMortas.setText("0");

        jLabel22.setFont(new java.awt.Font("Tempus Sans ITC", 1, 14));
        jLabel22.setText("R.I.P.");

        jLAmarelasMortas.setText("0");

        jLabel21.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Damas/face-worried.png"))); // NOI18N

        jLabel23.setFont(new java.awt.Font("Tw Cen MT", 1, 18));
        jLabel23.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel23.setText("Placar");

        jLPlacarVermelho.setFont(new java.awt.Font("Wide Latin", 1, 24));
        jLPlacarVermelho.setForeground(new java.awt.Color(255, 0, 0));
        jLPlacarVermelho.setText("0");

        jLPLacarAmarelo.setFont(new java.awt.Font("Wide Latin", 1, 24));
        jLPLacarAmarelo.setForeground(new java.awt.Color(255, 255, 0));
        jLPLacarAmarelo.setText("0");

        jMenu1.setText("Jogo");
        jMenu1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenu1ActionPerformed(evt);
            }
        });

        jMenuItem1.setText("Novo Jogo");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Ajuda");

        jMenuItem2.setText("Sobre");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem2);

        jMenuBar1.add(jMenu2);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(46, 46, 46)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel18, javax.swing.GroupLayout.DEFAULT_SIZE, 15, Short.MAX_VALUE)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(jLabel11, javax.swing.GroupLayout.DEFAULT_SIZE, 15, Short.MAX_VALUE)
                        .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel13, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel15, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel16, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jLabel17, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPTabuleiro, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(36, 36, 36)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                            .addComponent(jLVermelhasMortas)
                            .addComponent(jLabel19)
                            .addComponent(jLabel20)
                            .addComponent(jLAmarelasMortas)
                            .addComponent(jLabel22)
                            .addComponent(jLabel21)))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                            .addComponent(jLPLacarAmarelo)
                            .addComponent(jLPlacarVermelho)
                            .addComponent(jLabel23, javax.swing.GroupLayout.PREFERRED_SIZE, 54, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTFVermelho, javax.swing.GroupLayout.PREFERRED_SIZE, 141, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTFAmarelo, javax.swing.GroupLayout.PREFERRED_SIZE, 141, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel3))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLVezAmarelo)
                            .addComponent(jLVezVermelho))))
                .addGap(33, 33, 33)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPanel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(26, 26, 26)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLPlacarVermelho)
                                        .addGap(37, 37, 37)
                                        .addComponent(jLPLacarAmarelo))
                                    .addGroup(layout.createSequentialGroup()
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel3)
                                            .addComponent(jLVezVermelho)
                                            .addComponent(jTFVermelho, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE))
                                        .addGap(30, 30, 30)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jLVezAmarelo)
                                            .addComponent(jLabel4)
                                            .addComponent(jTFAmarelo, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                            .addComponent(jLabel23))
                        .addGap(21, 21, 21)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel12, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel13, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel15, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel16, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel17, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jLabel18, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jPTabuleiro, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(165, 165, 165)
                        .addComponent(jLabel20)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel19)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLVermelhasMortas)
                        .addGap(43, 43, 43)
                        .addComponent(jLabel22)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel21)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLAmarelasMortas)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenu1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenu1ActionPerformed
    }//GEN-LAST:event_jMenu1ActionPerformed

    /*
     * Ações executadas quando o cliente clica no Menu Jogo
     * Caso seja o primeiro jogo, uma nova conexão é estabelecida e a ThreadCLiente é disparada para
     * tratar as mensagens recebidas pelo cliente
     *
     * Caso contrário, uma mensagem é enviada ao servidor, indicando que o jogador está desistindo da partida
     * e quer recomeçar
     */
    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        if (this.primeiroJogo == true) {
            this.primeiroJogo = false;
            this.nomeLocal = JOptionPane.showInputDialog(null, "Insira seu nome");
            this.ip = JOptionPane.showInputDialog(null, "Insira o endereço IP do Servidor");
            this.porta = Integer.parseInt(JOptionPane.showInputDialog(null, "Insira a porta do servidor"));

            try {
                Socket client = new Socket(InetAddress.getByName(this.ip), this.porta);
                System.out.println("Conectado: " + client.getInetAddress().getHostName());
                output = new ObjectOutputStream(client.getOutputStream());
                output.flush();
                Thread comInterface = new ThreadCliente(this, client, output, nomeLocal);
                comInterface.start();
            } catch (IOException ex) {
                Logger.getLogger(Jogo.class.getName()).log(Level.SEVERE, null, ex);
            }
        } else {
            this.enviaMensagem(new Mensagem(24, ""));
        }
    }//GEN-LAST:event_jMenuItem1ActionPerformed


    /*
     * Método que recebe os cliques do mouse do tabuleiro
     */
    private void jPTabuleiroMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPTabuleiroMouseClicked
        int x = evt.getX();
        int y = evt.getY();


        //converte as posições recebidas em pixels para inteiros 8x8
        //assim a lógica para tratar os cliques nas casas do tabuleiro fica simplificada
        int fx = x / 50;
        int fy = y / 50;


        //envia para o Painel a posição clicada X/Y
        ((Painel) jPTabuleiro).movimentos(fx, fy);

    }//GEN-LAST:event_jPTabuleiroMouseClicked

    private void jPCorMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPCorMouseClicked
        Cores c = new Cores(this);
        c.setVisible(true);
        //this.jPCor.setBackground(Color.red);
}//GEN-LAST:event_jPCorMouseClicked

    private void jBEnviarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBEnviarActionPerformed
        if (jTFBatePapo.getText().equals("")) { //nao deixa enviar mensagens sem texto
            return;
        } else {
            String temp = "";
            int index = jCBFonte.getSelectedIndex();
            switch (index) {
                case 0: {
                    temp = nomeLocal + " diz: " + transformaHTML(jTFBatePapo.getText(), jTFBatePapo.getFont(), cor);
                    break;
                }
                case 1: {
                    temp = nomeLocal + " diz: " + transformaHTML(jTFBatePapo.getText(), new Font("Arial", Font.PLAIN, 12), cor);
                    break;
                }
                case 2: {
                    temp = nomeLocal + " diz: " + transformaHTML(jTFBatePapo.getText(), new Font("Century Gotic", Font.PLAIN, 12), cor);
                    break;
                }
                case 3: {
                    temp = nomeLocal + " diz: " + transformaHTML(jTFBatePapo.getText(), new Font("Comic Sans MS", Font.PLAIN, 12), cor);
                    break;
                }
                case 4: {
                    temp = nomeLocal + " diz: " + transformaHTML(jTFBatePapo.getText(), new Font("Tahoma", Font.PLAIN, 12), cor);
                    break;
                }
            }

            //String temp = nomeLocal + " diz: " + transformaHTML(jTFBatePapo.getText(), new Font("Arial",Font.PLAIN,12), cor); //gera o código HTML para usar no jEditorPane
            chat.append(temp); //salva o texto em um string buffer
            jEPBatePapo.setText(chat.toString());
            this.enviaMensagem(new Mensagem(100, temp)); //envia a mensagem digitada para o outro cliente através do servidor
            jTFBatePapo.setText(""); //apaga o texto digitado



        }

    }//GEN-LAST:event_jBEnviarActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        Sobre s = new Sobre(this,true);
        s.setLocationRelativeTo(this);
        s.setVisible(true);
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    public void historico1(int ox, int oy, int dx, int dy, boolean b){
        String co="", origem="", destino="";
        if(b){
            co="Amarelo";
        } else{
            co = "Vermelho";
        }
        switch (oy){
            case 0: origem = "A";
            break;
            case 1: origem = "B";
            break;
            case 2: origem = "C";
            break;
            case 3: origem = "D";
            break;
            case 4: origem = "E";
            break;
            case 5: origem = "F";
            break;
            case 6: origem = "G";
            break;
            case 7: origem = "H";
            break;
        }
        switch (dy){
            case 0: destino = "A";
            break;
            case 1: destino = "B";
            break;
            case 2: destino = "C";
            break;
            case 3: destino = "D";
            break;
            case 4: destino = "E";
            break;
            case 5: destino = "F";
            break;
            case 6: destino = "G";
            break;
            case 7: destino = "H";
            break;
        }
        
        this.historico.append(co+": "+(ox+1)+""+origem+">"+(dx+1)+""+destino+"\n");
        jTAHist.setText(this.historico.toString());
              
        
    }

    /**
     * Gerador de código html
     * @param message Mensagem que será usada
     * @param font Fonte que será usada
     * @param color Cor que será usada
     * @return
     */
    public String transformaHTML(String message, Font font, Color color) {
        String html = "<span style=\"color:#" + Integer.toHexString(color.getRGB()).substring(2)
                + "; font-family:"
                + font.getFamily()
                + "; font-size:"
                + font.getSize()
                + "pt; font-weight:"
                + (font.getStyle() == Font.BOLD ? "bold" : "")
                + "\">"
                + message
                + "<br>"
                + "</span>";
        return html;
    }

    //Método para enviar as mensagens do batepapo
    //Método para mudar a cor da fonte
    /**
     * @param b Quem ganhou o jogo?
     */
    public void acabaJogo(boolean b) {
        //verifica quem ganhou o jogo e mostra a mensagem na tela
        if (this.minhaCor == b) {
            JOptionPane.showMessageDialog(this, "Você ganhou");
        } else {
            JOptionPane.showMessageDialog(this, "Você perdeu");
        }

        if (b) {
            this.placarAmarelo += 1;
            jLPLacarAmarelo.setText("" + this.placarAmarelo);
        } else {
            this.placarVermelho += 1;
            jLPlacarVermelho.setText("" + this.placarVermelho);
        }


    }

    /**
     * Mensagem recebida do outro cliente para o bate-papo
     * @param t
     */
    public void escreveBatePapo(String t) {
        chat.append(t); //salva a mensagem
        jEPBatePapo.setText(chat.toString()); //mostra a mensagem na tela
    }

    /**
     * @param texto Nome do jogador adversário
     * @param primeiro Indica qual peça será o jogador, true = amarela, false = vermelha
     */
    public void setNomes(String texto, boolean primeiro) {
        if (primeiro) {
            jTFAmarelo.setText(nomeLocal);
            this.nomeRemoto = texto;
            jTFVermelho.setText(texto);
            this.minhaCor = primeiro;
            this.defineJogadores(primeiro);
        } else {
            jTFAmarelo.setText(texto);
            this.nomeRemoto = texto;
            jTFVermelho.setText(nomeLocal);
            this.minhaCor = primeiro;
            this.defineJogadores(primeiro);
        }
    }

    /**
     * @param amarela Quantidade de peças amarelas
     * @param vermelha Quantodade de peças vermelhas
     */
    public void recebeQuantidade(int amarela, int vermelha) {
        quantidadeAmarelas = amarela;
        quantidadeVermelhas = vermelha;
        //Mostra na tela a quantidade de peças mortas de cada jogador
        jLVermelhasMortas.setText("" + (12 - quantidadeVermelhas));
        jLAmarelasMortas.setText("" + (12 - quantidadeAmarelas));
    }

    /**
     * @param m Mensagem que será enviada
     */
    public void enviaMensagem(Mensagem m) {
        //envia a mensagem recebida no método para o servidor
        try {
            output.writeObject(m);
            output.flush();
            output.reset();
        } catch (IOException cnfex) {
            System.out.println("\nError writing object");
        }
    }

    public void defineJogadores(Boolean AmareloVermelho) {
        //indica ao Painel, qual peça será cada jogador
        //define algumas variáveis para desabilitar o jogador vermelho de começar jogando
        //o jogador amarelo, é o primeiro a conectar com o servidor e o primeiro a iniciar as jogadas
        if (AmareloVermelho) {
            ((Painel) jPTabuleiro).DefineJogador(true);
            ((Painel) jPTabuleiro).minhaVez(true);
            jLVezAmarelo.setVisible(true);
        } else {
            ((Painel) jPTabuleiro).DefineJogador(false);
        }
    }

    /**
     * @param al ArrayList dos maiores caminhos que devem ser feitos
     */
    public void desenharQuadradoAzul(ArrayList<String> al) {
        //chama método para desenhar na tela, uma indicação de possíveis jogadas ao cliente
        ((Painel) jPTabuleiro).desenharQuadradoAzul(al);
    }

    /**
     * @param p Novo tabuleiro recebido do servidor
     * @param vez Muda a vez dos clientes
     */
    public void desenharNovoTabuleiro(Pecas[][] p, boolean vez) {
        //chama métodos para desenhar o novo tabuleiro e trocar a vez dos cliente a cada jogada
        ((Painel) jPTabuleiro).setNovoTabuleiro(p);
        ((Painel) jPTabuleiro).minhaVez(vez);
    }

    public void novoTabuleiroOutroJogo(Pecas[][] p) {
        ((Painel) jPTabuleiro).tabuleiroNovoJogo(p);
        minhaCor = !minhaCor;
        /*if (jLVezAmarelo.isVisible()) {
        jLVezAmarelo.setVisible(false);
        jLVezVermelho.setVisible(true);
        } else {
        jLVezAmarelo.setVisible(true);
        jLVezVermelho.setVisible(false);
        }*/
        if (jTFAmarelo.getText().equals(nomeLocal)) {
            jTFAmarelo.setText(nomeRemoto);
            jTFVermelho.setText(nomeLocal);
        } else {
            jTFAmarelo.setText(nomeLocal);
            jTFVermelho.setText(nomeRemoto);
        }
        ((Painel) jPTabuleiro).minhaVez(true);
        jLVezAmarelo.setVisible(true);
        jLVezVermelho.setVisible(false);

        int temp = placarAmarelo;
        this.placarAmarelo=this.placarVermelho;
        this.placarVermelho=temp;

        jLPLacarAmarelo.setText(""+this.placarAmarelo);
        jLPlacarVermelho.setText("" + this.placarVermelho);
    }

    /**
     * @param b Boolean com a vez de quem deve jogar na rodada
     */
    public void setSeta(boolean b) {
        //coloca uma indicação na tela para mostrar aos jogadores de quem é a vez
        if (b) {
            jLVezAmarelo.setVisible(true);
            jLVezVermelho.setVisible(false);
        } else {
            jLVezAmarelo.setVisible(false);
            jLVezVermelho.setVisible(true);
        }
    }

    /**
     * @param c Cor da letra recebida
     */
    public void Cor(Color c) {
        //define a cor da fonte do batepapo
        this.cor = c;
        this.jPCor.setBackground(cor);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new Jogo().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBEnviar;
    private javax.swing.JComboBox jCBFonte;
    private javax.swing.JTextPane jEPBatePapo;
    private javax.swing.JLabel jLAmarelasMortas;
    private javax.swing.JLabel jLPLacarAmarelo;
    private javax.swing.JLabel jLPlacarVermelho;
    private javax.swing.JLabel jLVermelhasMortas;
    private javax.swing.JLabel jLVezAmarelo;
    private javax.swing.JLabel jLVezVermelho;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JPanel jPCor;
    private javax.swing.JPanel jPTabuleiro;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextPane jTAHist;
    private javax.swing.JTextField jTFAmarelo;
    private javax.swing.JTextField jTFBatePapo;
    private javax.swing.JTextField jTFVermelho;
    // End of variables declaration//GEN-END:variables
}
