/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <alucassch@gmail.com> and <brunomarcosespindola@gmail.com> wrote this file.
 * As long as you retain this notice you can do whatever you want with this stuff.
 * If we meet some day, and you think this stuff is worth it, you can buy
 * me a beer in return André Lucas Schlichting e Bruno Marcos Espindola
 * ----------------------------------------------------------------------------
 */

/*
 * Tradução da Licensa
 *  ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <alucassch@gmail.com> e <brunomarcosespindola@gmail.com>  escreveram esse código.
 * Enquanto você possui-lo, note que  você pode fazer o que desejar com ele. Se um
 * dia a gente se conhecer, e você achar que isso funciona, você pode nos comprar
 * uma cerveja em homenagem a André Lucas Schlichting e Bruno Marcos Espindola
 * ----------------------------------------------------------------------------
 */


package Damas;

import Protocolo.Mensagem;
import java.awt.Color;
import java.awt.Graphics;
import java.util.ArrayList;
import javax.swing.ImageIcon;
import javax.swing.JPanel;

public class Painel extends JPanel {

    private ImageIcon vermelha; //armazena o ícone correspondente a peça vermelha
    private ImageIcon amarela; //armazena o ícone correspondente a peça amarela
    private ImageIcon vermelhaRainha; //armazena o ícone correspondente a peça vermelha quando esta é uma dama
    private ImageIcon amarelaRainha; //armazena o ícone correspondente a peça amarela quando esta é uma dama
    private boolean preenchido; //variável auxiliar para colocar as peças no tabuleiro
    private Pecas[][] tabuleiro; //variável que possui as peças do tabuleiro
    private boolean selecionado = false; //variável que indica se há alguma peça selecionada
    private int selecionadoX; //armazena a posição X da peça selecionada
    private int selecionadoY; //armazena a posição Y da peça selecionada
    private boolean jogadorVez; //armazena se este jogador será a peça amarela ou a peça vermelha
    private Jogo jogo; //variável correspondente a classe Jogo
    private boolean minhaVez = false; //armazena de quem é a rodada, se é do jogador amarelo ou vermelho

    /*
     * Construtor da classe Painel
     */
    public Painel(Jogo jogo) {
        this.jogo = jogo;
        vermelha = new ImageIcon(this.getClass().getResource("face-angry.png"));
        amarela = new ImageIcon(this.getClass().getResource("face-worried.png"));
        vermelhaRainha = new ImageIcon(this.getClass().getResource("rainhapreta.png"));
        amarelaRainha = new ImageIcon(this.getClass().getResource("rainhabranca.png"));
        // alterar a cor de fundo do painel
        this.setBackground(Color.WHITE);
        this.preenchido = false;

        this.tabuleiro = new Pecas[8][8];

        //criando o tabuleiro que será usado na classe painel durante o jogo com as peças
        for (int lin = 0; lin < 8; lin++) { //percorrendo linhas
            // determinando a cor da peca
            // false = preta
            // true = branca
            boolean cor = (lin > 4) ? true : false;
            for (int col = 0; col < 8; col++) { //percorrendo colunas
                if ((lin != 3 && lin != 4) && (((lin % 2 == 0) && (col % 2 == 1)) || ((lin % 2 == 1) && (col % 2 == 0)))) {
                    this.tabuleiro[lin][col] = new Pecas(cor, false);
                }
            }
        }
    }

    @Override
    public void paint(Graphics g) {
        super.paint(g);
        this.desenharTabuleiro(g);
        this.preencherPecas(g);
    }

    /**
     * @param p Tabuleiro recebido do servidor
     */
    public void setNovoTabuleiro(Pecas[][] p) {
        //define o tabuleiro do cliente como igual ao recebido do servidor
        //para haver uma 'sincronização'
        this.tabuleiro = p;
        Graphics g = this.getGraphics();
        //redesenha o tabuleiro
        this.desenharTabuleiro(g);
        this.preencherPecas(g);
    }

    public void tabuleiroNovoJogo(Pecas[][] p) {
        for (int lin = 0; lin < 8; lin++) {
            for (int col = 0; col < 8; col++) {
                tabuleiro[lin][col] = null;
            }
        }

        for (int lin = 0; lin < 8; lin++) { //percorrendo linhas
            // determinando a cor da peca
            // false = preta
            // true = branca
            boolean cor = (lin > 4) ? true : false;
            for (int col = 0; col < 8; col++) { //percorrendo colunas
                if ((lin != 3 && lin != 4) && (((lin % 2 == 0) && (col % 2 == 1)) || ((lin % 2 == 1) && (col % 2 == 0)))) {
                    this.tabuleiro[lin][col] = new Pecas(cor, false);
                }
            }
        }
        //this.tabuleiro=p;
        Graphics g = this.getGraphics();
        this.desenharTabuleiro(g);
        this.preencherPecas(g);
        this.jogadorVez=!jogadorVez;
    }

    /**
     * @param b Que jogador serei?
     */
    public void DefineJogador(Boolean b) {
        this.jogadorVez = b; //define o jogador que será esse cliente, dependendo da ordem de conexão ao servidor
    }

    //Método para desenhar o tabuleiro
    public void desenharTabuleiro(Graphics g) {
        //Graphics g = this.getGraphics();

        for (int i = 0; i < 400; i += 50) {
            for (int j = 0; j < 400; j += 50) {
                if (this.preenchido == false) {
                    g.setColor(Color.white);
                    g.fillRect(i, j, 50, 50);
                } else {
                    g.setColor(Color.black);
                    g.fillRect(i, j, 50, 50);
                }
                // novo valor sera' igual ao antigo valor negado
                this.preenchido = !this.preenchido;
            }
            this.preenchido = !this.preenchido;
        }
        g.setColor(Color.black);
        g.drawRect(0, 0, 399, 399);
    }

    //Método para colocar as peças no tabuleiro
    public void preencherPecas(Graphics g) {
        // Graphics g = this.getGraphics();

        for (int lin = 0; lin < 8; lin++) {
            for (int col = 0; col < 8; col++) {
                if (this.tabuleiro[lin][col] != null) {
                    if (tabuleiro[lin][col].getCor() == false) {
                        if (tabuleiro[lin][col].getRainha()) {
                            g.drawImage(vermelhaRainha.getImage(), 1 + (50 * col), 1 + (50 * lin), this);
                        } else {
                            g.drawImage(vermelha.getImage(), 10 + (50 * col), 10 + (50 * lin), this);
                        }

                    } else {
                        if (tabuleiro[lin][col].getRainha()) {
                            g.drawImage(amarelaRainha.getImage(), 1 + (50 * col), 1 + (50 * lin), this);
                        } else {
                            g.drawImage(amarela.getImage(), 10 + (50 * col), 10 + (50 * lin), this);
                        }

                    }
                }
            }
        }
    }

    public void minhaVez(boolean vez) {
        this.minhaVez = vez;
    }


    /*
     * recebe como parâmetros dois inteiros Y e X que são as respectivas posições do clique do mouse no tabuleiro
     * Trata a parte de selecionar as peças para indicar visualmente ao jogador selecionando a peça clicada
     * Quando é feita uma jogada, tanto para mover, quanto para comer, é enviada a mensagem apropriada ao servidor
     */
    public void movimentos(int y, int x) {
        Graphics gr = this.getGraphics();
        if (this.minhaVez == this.jogadorVez) { //verifica se é a ver do jogador que está tentando mover
            if (this.selecionado == false) { //verifica se não há nenhuma peça selecionada
                if (this.tabuleiro[x][y] != null) { //verifica se existe uma peça na casa clicada
                    if ((this.tabuleiro[x][y].getCor()) == jogadorVez) { //verifica se a peça clicada é do jogador da vez
                        //desenha um quadrado ao redor da peça para indicar que ela está selecionada
                        gr.setColor(Color.ORANGE);
                        gr.drawRoundRect((y * 50) + 5, (x * 50) + 5, 40, 40, 5, 5);
                        selecionado = true;
                        this.selecionadoX = x;
                        this.selecionadoY = y;
                    }
                }
            } else {
                if (tabuleiro[x][y] != null) { //já havia uma peça selecionada
                    if (tabuleiro[x][y].getCor() == tabuleiro[selecionadoX][selecionadoY].getCor()) { //verifica se a nova peça selecionada é do mesmo jogador para selecionar a outra peça
                        this.desenharTabuleiro(gr);
                        this.preencherPecas(gr);
                        gr.setColor(Color.ORANGE);
                        gr.drawRoundRect((y * 50) + 5, (x * 50) + 5, 40, 40, 5, 5);
                        this.selecionadoX = x;
                        this.selecionadoY = y;
                    }
                } else { //a segunda casa clicada, é uma casa vazia, o que provavelmente caracteriza um movimento que será tratado pelo servidor
                    this.selecionado = false;
                    if ((casaPreta(x, y)) && (casaVazia(x, y))) { //verifica se a casa destino é uma casa preta e está vazia, para evitar algumas mensagens desnecessárias ao servidor
                        //envia a mensagem 13 para o servidor com as posições das peças selecionadas e o destino clicado, além de quem fez a jogada
                        jogo.enviaMensagem(new Mensagem(13, this.selecionadoX, this.selecionadoY, x, y, jogadorVez));
                        this.desenharTabuleiro(gr);
                        this.preencherPecas(gr);
                    } else {
                        return;
                    }
                }
            }

        }
    }

    public void desenharQuadradoAzul(ArrayList<String> al) {
        Graphics gr = this.getGraphics();
        for (int i = 0; i < al.size(); i++) {
            String azul = al.get(i);
            System.out.println("STRING=" + azul);
            System.out.println("LENGTH=" + azul.length());
            System.out.println("POSICAO" + azul.substring(azul.length() - 1, azul.length()));
            gr.setColor(Color.BLUE);
            gr.drawRoundRect((Integer.parseInt(azul.substring(1, 2)) * 50) + 5, (Integer.parseInt(azul.substring(0, 1)) * 50) + 5, 40, 40, 5, 5);
            gr.setColor(Color.RED);
            gr.drawRoundRect((Integer.parseInt(azul.substring(azul.length() - 1, azul.length())) * 50) + 5, (Integer.parseInt(azul.substring(azul.length() - 2, azul.length() - 1)) * 50) + 5, 40, 40, 5, 5);



        }
    }

    private boolean casaPreta(int dx, int dy) {
        if (((dy % 2 == 0) && (dx % 2 == 1)) || ((dy % 2 == 1) && (dx % 2 == 0))) {
            return true;
        }
        return false;
    }

    private boolean casaVazia(int dx, int dy) {
        if ((tabuleiro[dx][dy] == null)) {
            return true;
        }
        return false;
    }
}
