/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <alucassch@gmail.com> and <brunomarcosespindola@gmail.com> wrote this file.
 * As long as you retain this notice you can do whatever you want with this stuff.
 * If we meet some day, and you think this stuff is worth it, you can buy
 * me a beer in return André Lucas Schlichting e Bruno Marcos Espindola
 * ----------------------------------------------------------------------------
 */

/*
 * Tradução da Licensa
 *  ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <alucassch@gmail.com> e <brunomarcosespindola@gmail.com>  escreveram esse código.
 * Enquanto você possui-lo, note que  você pode fazer o que desejar com ele. Se um
 * dia a gente se conhecer, e você achar que isso funciona, você pode nos comprar
 * uma cerveja em homenagem a André Lucas Schlichting e Bruno Marcos Espindola
 * ----------------------------------------------------------------------------
 */


package Damas;

import Protocolo.Mensagem;
import java.io.EOFException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.io.Serializable;
import javax.swing.JOptionPane;

/**
 *
 * @author Andre
 */
public class ThreadCliente extends Thread implements Serializable {

    private Jogo tab; //objeto da classe Jogo
    private ObjectOutputStream out; //fluxo de saída do cliente
    private Socket cli; //armazena o socket criado
    private String Nome; //armazena o nome do cliente

    ThreadCliente(Jogo aThis, Socket c, ObjectOutputStream ob, String nome) {
        this.tab = aThis;
        this.out = ob;
        this.cli = c;
        this.Nome = nome;
    }

    @Override
    public void run() {
        try {
            //meuNome = JOptionPane.showInputDialog("Entre com seu nome");

            //Cria socket pra fazer a conexão
            System.out.println("Tentando conectar ao servidor\n");

            ObjectInputStream input = new ObjectInputStream(cli.getInputStream());
            System.out.println("\nFluxos estabelecidos\n");

            //enviando nomedocliente para o servidor;
            //codigo 15 indica nome do cliente
            System.out.println("'NOME=" + Nome);
            tab.enviaMensagem(new Mensagem(15, Nome));

            // Conexão....

            Mensagem recebida = null;

            do {
                try {

                    recebida = (Mensagem) input.readObject(); //espera mensagens do servidor


                    switch (recebida.codigo) {
                        //a primeira mensagem recebida
                        //para começar o jogo
                        //recebe o nome do cliente adversário
                        case 15: {
                            System.out.println("NOMELOCAL=" + Nome);
                            System.out.println("NOMERECEBIDO=" + recebida.texto);
                            tab.setNomes(recebida.texto, recebida.primeiro);
                            break;
                        }


                        //mensagem com código 65 indica que não foi executada uma jogada que deveria ter sido, que é o caso de comer uma peça quando há uma para comer
                        case 65: {
                            //chama métodos para indicar na tela as possibilidades de peças para comer
                            tab.desenharQuadradoAzul(recebida.maiorCaminho);
                            break;
                        }

                        //mensagem com código 20 indica uma jogada realizada
                        case 20: {
                            //chama métodos para trocar a vez e redesenhar o novo tabuleiro na tela do cliente
                            tab.desenharNovoTabuleiro(recebida.pecas, recebida.vez);
                            tab.setSeta(recebida.vez);
                            break;
                        }

                        //mensagem com código 100 indica uma mensagem recebida do outro cliente para o bate-papo
                        case 100: {
                            //chama método para mostrar e salvar a mensagem recebida
                            tab.escreveBatePapo(recebida.texto);
                            break;
                        }

                        //mensagem com código 48 indica mensagem recebendo do servidor com a quantidade de peças de cada jogador
                        case 48: {
                            tab.recebeQuantidade(recebida.contadorAmarelas, recebida.contadorVermelhas);
                            break;
                        }

                        //mensagem com código 49 indica que o jogador vermelho ganhou o jogo
                        case 49: {
                            //chama método para mostrar uma mensagem indicando que o jogador vermelho (false) ganhou o jogo
                            tab.acabaJogo(false);
                            break;
                        }

                        //mensagem com código 50 indica que o jogador amarelo ganhou o jogo
                        case 50: {
                        //chama método para mostrar uma mensagem indicando que o jogador amarelo (true) ganhou o jogo
                            tab.acabaJogo(true);
                            break;
                        }

                        //mensagem com código 51 indica que o jogo empatou
                        case 51: {
                            //mostra uma mensagem indicando que o jogo empatou
                            JOptionPane.showMessageDialog(null, "O jogo empatou");
                            break;
                        }

                        case 25: {
                            int op = JOptionPane.showConfirmDialog(null, "Quer começar novamente?", "Novo jogo", JOptionPane.YES_NO_OPTION);
                            if (op == 0) {
                                tab.enviaMensagem(new Mensagem(26, true));
                            }
                            if (op == 1 || op == -1) {
                                tab.enviaMensagem(new Mensagem(26, false));
                            }
                            break;
                        }

                        case 27:{
                            tab.novoTabuleiroOutroJogo(recebida.pecas);
                            break;
                        }
                        case 28:{
                            JOptionPane.showMessageDialog(null, "O outro jogador não quer começar uma nova partida. Faça sua jogada!");
                            break;
                        }
                        case 33:{
                            tab.historico1(recebida.SelecionadoX, recebida.SelecionadoY, recebida.destinoX, recebida.destinoY,recebida.corJogador);
                            break;
                        }

                        default: {
                            break;
                        }

                    }

                } catch (ClassNotFoundException cnfex) {
                    System.out.println("\nUnknown object type received");
                }
            } while (recebida.codigo != 10);
            // Encerra conexão
            System.out.println("Fim de conexao\n");
            out.close();
            input.close();
            cli.close();

        } catch (EOFException eof) {
            System.out.println("Servidor encerrou a conexao");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
