/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <alucassch@gmail.com> and <brunomarcosespindola@gmail.com> wrote this file.
 * As long as you retain this notice you can do whatever you want with this stuff.
 * If we meet some day, and you think this stuff is worth it, you can buy
 * me a beer in return André Lucas Schlichting e Bruno Marcos Espindola
 * ----------------------------------------------------------------------------
 */

/*
 * Tradução da Licensa
 *  ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <alucassch@gmail.com> e <brunomarcosespindola@gmail.com>  escreveram esse código.
 * Enquanto você possui-lo, note que  você pode fazer o que desejar com ele. Se um
 * dia a gente se conhecer, e você achar que isso funciona, você pode nos comprar
 * uma cerveja em homenagem a André Lucas Schlichting e Bruno Marcos Espindola
 * ----------------------------------------------------------------------------
 */

package Servidor;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import javax.swing.JOptionPane;
import Damas.Pecas;

/**
 *
 *
 */
public class Servidor {

    public static void main(String[] args) {
        // armazena o socket de todos os clientes conectados
        ArrayList<ObjectOutputStream> clientes = new ArrayList<ObjectOutputStream>();
        ArrayList<String> nomeClientes = new ArrayList<String>();

        try {
            int porta = Integer.parseInt(JOptionPane.showInputDialog(null,"PORTA"));
            boolean jogadorVez =true;
            Pecas[][] tabuleiro = new Pecas[8][8];
            for (int lin = 0; lin < 8; lin++) { //percorrendo linhas
                // determinando a cor da peca
                // false = preta
                // true = branca
                boolean cor = (lin > 4) ? true : false;
                for (int col = 0; col < 8; col++) { //percorrendo colunas
                    if ((lin != 3 && lin != 4) && (((lin % 2 == 0) && (col % 2 == 1)) || ((lin % 2 == 1) && (col % 2 == 0)))) {
                        tabuleiro[lin][col] = new Pecas(cor, false);
                    }
                }
            }
            ServerSocket servidor = new ServerSocket(porta);
            while (true) {
                // esperando por conexoes
                // fica bloqueado até algum cliente conectar
                Socket conexao = servidor.accept();

                // se houve conexao, então dispare uma thread para interagir com o cliente
                Thread t = new ThreadServidor(conexao, clientes, nomeClientes,tabuleiro,jogadorVez);
                t.start();
            }

        } catch (IOException ex) {
            System.err.println(ex.toString());
        }
    }
}
